/*
 * yasapi_defines.h
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef __YASAPI_DEFINES_H__ // [
#define __YASAPI_DEFINES_H__

#ifdef __cplusplus // [
extern "C" {
#endif // ]

///////////////////////////////////////////////////////////////////////////////
//#define YASAPI_DEBUG
//#define YASAPI_ABOUT_TEXT_VIEW
#define YASAPI_DEVICE_MARKUP
//#define YASAPI_ENGINE_REGISTER_WHEN_STARING
//#define YASAPI_PRODUCTBUILD
//#define YASAPI_OPTION_VOLUME
//#define YASAPI_OPTION_GAPLESS
//define YASAPI_OPTION_BITDEPTH
//#define YASAPI_OPTION_DISCONNECT
#define YASAPI_CLOCK
//#define YASAPI_PAUSE_CONNECTED2
#define YASAPI_FRIENDLY_NAME_ORIGINAL
#define YASAPI_OPTIONS_DIALOG
#define YASAPI_OPTIONS_DIALOG_SAVE

#if defined (YASAPI_CLOCK) // [
#define YASAPI_HISTORY
#endif // ]

#if defined (_MSC_VER) // [
//#define YASAPI_FILE_OPEN_DIALOG
#endif // ]

#if ! defined (YASAPI_DEBUG) // [
#define YASAPI_AV_THREAD_CHARACTERISTICS
#endif // ]

#if defined (_MSC_VER) // [
///////////////////////////////////////////////////////////////////////////////
#define __func__ __FUNCTION__
#endif // ]

///////////////////////////////////////////////////////////////////////////////
#define _YASAPI_STR(id) \
    #id
#define YASAPI_STRA(id) \
    _YASAPI_STR(id)
#define YASAPI_STRW(id) \
    L ## _YASAPI_STR(id)

#define YASAPI_ARRAYSIZE(a) \
		(sizeof (a))/(sizeof (a)[0])

///////////////////////////////////////////////////////////////////////////////
#if ! defined (YASAPI_VERSION) // [
#define YASAPI_VERSION 0.0.0
#endif // ]

#if defined (__GNUC__) // [
#define YASAPI_TITLE_VERSION_SFX "/gcc "
#elif defined (_MSC_VER) // [
#define YASAPI_TITLE_VERSION_SFX "/msc "
#else // ] [
#define YASAPI_TITLE_VERSION_SFX ""
#endif // ]

#define YASAPI_TITLE_VERSION \
		YASAPI_STRA(YASAPI_VERSION) YASAPI_TITLE_VERSION_SFX

#define YASAPI_TITLE "YASAPI NT Output v" YASAPI_TITLE_VERSION

///////////////////////////////////////////////////////////////////////////////
#define DMESSAGE(format) \
		yasapi_message(__FILE__,__LINE__,format,0ul)
/*
#define DMESSAGESYS(format) \
		yasapi_message(__FILE__,__LINE__,format,GetLastError())
*/
#define DVMESSAGE(format,...) \
		yasapi_message(__FILE__,__LINE__,format,0ul,__VA_ARGS__)
/*
#define DVMESSAGEW(format,...) \
		yasapi_messagew(__FILE__,__LINE__,format,0ul,__VA_ARGS__)
#define DVMESSAGESYS(format,...) \
		yasapi_message(__FILE__,__LINE__,format,GetLastError(),__VA_ARGS__)
*/
#define DCMESSAGE(m,label) case label: \
    DMESSAGE(m " failed with " #label); \
    break
#define DVCMESSAGE(m,label,...) case label: \
    DVMESSAGE(m " failed with " #label,__VA_ARGS__); \
    break
#define DDMESSAGE(m,hr) default: \
    DVMESSAGE(m " failed with unknown %p",hr); \
    break
#define DVDMESSAGE(m,hr,...) default: \
    DVMESSAGE(m " failed with unknown %p",__VA_ARGS__,hr); \
    break

///////////////////////////////////////////////////////////////////////////////
#if defined (YASAPI_DEBUG) // [
#define DBASENAME(path) \
  yasapi_basenamea (path)
#define DMARKLN() do { \
  fprintf(stderr,"[%s:%d:%s]\n",DBASENAME(__FILE__),__LINE__,__func__); \
  fflush (stderr); \
} while (0)
#define DWRITELN(line) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fputs(line,stderr); \
  fputs("\n",stderr); \
  fflush(stderr); \
} while (0)
#define DWRITELNW(line) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fputws(line,stderr); \
  fputs("\n",stderr); \
  fflush(stderr); \
} while (0)
#define DVWRITELN(format,...) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fprintf(stderr,format,__VA_ARGS__); \
  fputs("\n",stderr); \
  fflush (stderr); \
} while (0)
#define DVWRITELNW(format,...) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fwprintf(stderr,format,__VA_ARGS__); \
  fputs("\n",stderr); \
  fflush (stderr); \
} while (0)
#define DVWRITELNW(format,...) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fwprintf(stderr,format,__VA_ARGS__); \
  fputs("\n",stderr); \
  fflush (stderr); \
} while (0)
#define DASSERT(condition,label) do { \
  if (!(condition)) { \
    DMESSAGE(YASAPI_STRA(condition) " does not hold"); \
    goto label; \
  } \
} while (0)
#define DSLEEP(ms) \
  Sleep(ms)
#define DGETC() \
  fgetc(stdin)
#else // ] [
#define DMARKLN()
#define DWRITELN(s)
#define DWRITELNW(s)
//#define DWRITELN(format,...)
#define DVWRITELN(format,...)
//#define DWRITELNW(format,...)
#define DVWRITELNW(format,...)
#define DASSERT(confition,label)
#define DGETC()
#define DSLEEP(ms)
#endif // ]

///////////////////////////////////////////////////////////////////////////////
#define YASAPI_FRAMES2MS(uNumFrames,pwfx) \
  (1000.0*(uNumFrames)/(pwfx)->Format.nSamplesPerSec)
#define YASAPI_FRAMES2HNS(uNumFrames,pwfx) \
  (10.0*1000.0*1000.0*(uNumFrames)/(pwfx)->Format.nSamplesPerSec)
#define YASAPI_SIZE2FRAMES(dwSize,pwfx) \
  MulDiv(1,dwSize,(pwfx)->Format.nBlockAlign)

#ifdef __cplusplus // [
}
#endif // ]
#endif // __YASAPI_DEFINES_H__ ]
